# coding: utf-8

"""
    VRt.Universal [UV]

    The version of the OpenAPI document: 6.6.2006

    Generated by OpenAPI Generator: 6.5.0

    Do not edit the code manually

    2023 Veeroute
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist
from vrt_lss_universal.models.demand_fact import DemandFact
from vrt_lss_universal.models.order_fact import OrderFact
from vrt_lss_universal.models.performer_fact import PerformerFact
from vrt_lss_universal.models.transport_fact import TransportFact

class Facts(BaseModel):
    """
    Events that have taken place. 
    """
    order_facts: Optional[conlist(OrderFact, max_items=15001, min_items=0, unique_items=True)] = Field(None, description="List of order's facts.")
    demand_facts: Optional[conlist(DemandFact, max_items=15001, min_items=0, unique_items=True)] = Field(None, description="List of demand's facts.")
    performer_facts: Optional[conlist(PerformerFact, max_items=15001, min_items=0, unique_items=True)] = Field(None, description="List of performers's facts.")
    transport_facts: Optional[conlist(TransportFact, max_items=15001, min_items=0, unique_items=True)] = Field(None, description="List of transport's facts.")
    __properties = ["order_facts", "demand_facts", "performer_facts", "transport_facts"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Facts:
        """Create an instance of Facts from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in order_facts (list)
        _items = []
        if self.order_facts:
            for _item in self.order_facts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['order_facts'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in demand_facts (list)
        _items = []
        if self.demand_facts:
            for _item in self.demand_facts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['demand_facts'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in performer_facts (list)
        _items = []
        if self.performer_facts:
            for _item in self.performer_facts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['performer_facts'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in transport_facts (list)
        _items = []
        if self.transport_facts:
            for _item in self.transport_facts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['transport_facts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Facts:
        """Create an instance of Facts from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return Facts.parse_obj(obj)

        _obj = Facts.parse_obj({
            "order_facts": [OrderFact.from_dict(_item) for _item in obj.get("order_facts")] if obj.get("order_facts") is not None else None,
            "demand_facts": [DemandFact.from_dict(_item) for _item in obj.get("demand_facts")] if obj.get("demand_facts") is not None else None,
            "performer_facts": [PerformerFact.from_dict(_item) for _item in obj.get("performer_facts")] if obj.get("performer_facts") is not None else None,
            "transport_facts": [TransportFact.from_dict(_item) for _item in obj.get("transport_facts")] if obj.get("transport_facts") is not None else None
        })
        return _obj

