# coding: utf-8

"""
    VRt.Universal [UV]

    The version of the OpenAPI document: 6.6.2006

    Generated by OpenAPI Generator: 6.5.0

    Do not edit the code manually

    2023 Veeroute
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist, constr
from vrt_lss_universal.models.attribute import Attribute
from vrt_lss_universal.models.time_window import TimeWindow
from vrt_lss_universal.models.transport_tariff import TransportTariff

class TransportShift(BaseModel):
    """
    A transport work shift that determines the availability of a transport for scheduling within its availability time window. 
    """
    key: constr(strict=True, max_length=1024, min_length=1) = Field(..., description="Shift key, unique identifier.")
    availability_time: Optional[TimeWindow] = ...
    working_time: Optional[TimeWindow] = ...
    start_location_key: Optional[constr(strict=True, max_length=1024, min_length=1)] = Field(None, description="Start location key.  If the key is not set, then the transport path starts on the first order. ")
    finish_location_key: Optional[constr(strict=True, max_length=1024, min_length=1)] = Field(None, description="Finish location key.  If the key is not set, then the transport path ends at the last order. ")
    tariff: Optional[TransportTariff] = None
    attributes: Optional[conlist(Attribute, max_items=1000, min_items=0, unique_items=True)] = Field(None, description="Attributes. Used to add service information.")
    __properties = ["key", "availability_time", "working_time", "start_location_key", "finish_location_key", "tariff", "attributes"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TransportShift:
        """Create an instance of TransportShift from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of availability_time
        if self.availability_time:
            _dict['availability_time'] = self.availability_time.to_dict()
        # override the default output from pydantic by calling `to_dict()` of working_time
        if self.working_time:
            _dict['working_time'] = self.working_time.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tariff
        if self.tariff:
            _dict['tariff'] = self.tariff.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in attributes (list)
        _items = []
        if self.attributes:
            for _item in self.attributes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['attributes'] = _items
        # set to None if availability_time (nullable) is None
        # and __fields_set__ contains the field
        if self.availability_time is None and "availability_time" in self.__fields_set__:
            _dict['availability_time'] = None

        # set to None if working_time (nullable) is None
        # and __fields_set__ contains the field
        if self.working_time is None and "working_time" in self.__fields_set__:
            _dict['working_time'] = None

        # set to None if start_location_key (nullable) is None
        # and __fields_set__ contains the field
        if self.start_location_key is None and "start_location_key" in self.__fields_set__:
            _dict['start_location_key'] = None

        # set to None if finish_location_key (nullable) is None
        # and __fields_set__ contains the field
        if self.finish_location_key is None and "finish_location_key" in self.__fields_set__:
            _dict['finish_location_key'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TransportShift:
        """Create an instance of TransportShift from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return TransportShift.parse_obj(obj)

        _obj = TransportShift.parse_obj({
            "key": obj.get("key"),
            "availability_time": TimeWindow.from_dict(obj.get("availability_time")) if obj.get("availability_time") is not None else None,
            "working_time": TimeWindow.from_dict(obj.get("working_time")) if obj.get("working_time") is not None else None,
            "start_location_key": obj.get("start_location_key"),
            "finish_location_key": obj.get("finish_location_key"),
            "tariff": TransportTariff.from_dict(obj.get("tariff")) if obj.get("tariff") is not None else None,
            "attributes": [Attribute.from_dict(_item) for _item in obj.get("attributes")] if obj.get("attributes") is not None else None
        })
        return _obj

